//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  TGPMatrix  slӌ`̕`̈
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1214 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, ComCtrls;

type
  TMyPanel = class(TPanel)
  private
    FXAddValue : Single;
    FYAddValue : Single;
    procedure SetXAddValue(const Value: Single);
    procedure SetYAddValue(const Value: Single);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    property XAddValue : Single read FXAddValue write SetXAddValue;
    property YAddValue : Single read FYAddValue write SetYAddValue;
  end;

  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  TGPMatrix  slӌ`̕`̈';

  //`悷Rg[𐶐
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent := Self;
    SetBounds(5, 70, Self.ClientWidth - 10, Self.ClientHeight - 75);
    DoubleBuffered   := True;
    ControlStyle     := MyPanel.ControlStyle + [csOpaque];
    BevelOuter       := bvNone;
    Visible          := True;
    Color            := clWhite;
    ParentBackground := False;
    Anchors          := [akLeft, akTop, akRight, akBottom];
  end;

  //X̒lɉZl̐ݒ
  with TrackBar1 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := -300;
    Max      := 300;
    Position := 0;
  end;

  //Y̒lɉZl̐ݒ
  with TrackBar2 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := -300;
    Max      := 300;
    Position := 0;
  end;
end;

//=============================================================================
//  TrackBar1OnClickCxg
//  X̒lɉZl̐ݒ
//=============================================================================
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.XAddValue := TrackBar1.Position / 100.0;
end;

//=============================================================================
//  TrackBar2OnClickCxg
//  Y̒lɉZl̐ݒ
//=============================================================================
procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.YAddValue :=  TrackBar2.Position / 100.0;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RXgN^
//  evpeB̏
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  FXAddValue := 0.0;
  FYAddValue := 0.0;
end;

//-----------------------------------------------------------------------------
//  XAddValuevpeBݒp\bh
//  X̒lɉZl̐ݒ
//-----------------------------------------------------------------------------
procedure TMyPanel.SetXAddValue(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FXAddValue <> Value then begin
     FXAddValue := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  YAddValuevpeBݒp\bh
//  Y̒lɉZl̐ݒ
//-----------------------------------------------------------------------------
procedure TMyPanel.SetYAddValue(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FYAddValue <> Value then begin
     FYAddValue := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LObjWidth     : Integer;
  LObjHeight    : Integer;
  LObjRect      : TGPRect;
  LXLocation    : Integer;
  LYLocation    : Integer;
  LGPGraphic    : TGPGraphics;
  LGPBrush      : TGPHatchBrush;
  LGPFontFamily : TGPFontFamily;
  LGPStrFormat  : TGPStringFormat;
  LGPPath       : TGPGraphicsPath;
  LGPMatrix     : TGPMatrix;
  LGPPen        : TGPPen;
  LColor        : Cardinal;
begin
  inherited;

  //`悷lp`Ƒȉ~̗̈ƃTCY
  LObjWidth  := 130;
  LObjHeight := 100;
  LObjRect   := MakeRect(0, 0, LObjWidth, LObjHeight);

  //W_ʒu̒l
  LXLocation := Width  div 2;
  LYLocation := Height div 2;

  //TMyPanelCanvas`ɂTGPGraphics̃CX^X𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //W̌_ (FXLocation, FYLocation) Ɉړ
  LGPGraphic.TranslateTransform(LXLocation, LYLocation);

  //uV𐶐
  LColor   := ColorRefToARGB($804000);
@LGPPen   := TGPPen.Create(LColor, 1);
@LGPBrush := TGPHatchBrush.Create(HatchStyle30Percent, aclWhite, LColor);

@//̏ݒ
@LGPFontFamily := TGPFontFamily.Create('Arial Black');
@LGPStrFormat  := TGPStringFormat.Create;
@LGPStrFormat.SetAlignment(StringAlignmentCenter);
@LGPStrFormat.SetLineAlignment(StringAlignmentCenter);

@//pX𐶐Ďlp`Ƒȉ~ƕǉ
@LGPPath := TGPGraphicsPath.Create;
@LGPPath.AddRectangle(LObjRect);
@LGPPath.AddEllipse(LObjRect);
@LGPPath.AddString('DELPHI',
                    -1,
                    LGPFontFamily,
                    FontStyleRegular,
                    25,
                    LObjRect,
                    LGPStrFormat);

@//TGPMatrix𐶐ėvf
@LGPMatrix := TGPMatrix.Create;
  //}gbNX̏pXɓnāCpX`
@LGPMatrix.SetElements(1.0, FYAddValue,
@@@@@@@@@@    FXAddValue, 1.0,
@@@@@@@@@@    0.0, 0.0);
@LGPPath.Transform(LGPMatrix);
@LGPGraphic.FillPath(LGPBrush, LGPPath);
@LGPGraphic.DrawPath(LGPPen, LGPPath);


  //W_W`
  LGPPen.SetColor(aclBlack);
  LGPPen.SetWidth(1.0);
  LGPPen.SetDashStyle(DashStyleDash);
  LGPGraphic.DrawLine(LGPPen, 0, -LYLocation, 0, LYLocation);
  LGPGraphic.DrawLine(LGPPen, -LXLocation, 0, LXLocation, 0);

  //CreateIuWFNg͉
  LGPGraphic.Free;
  LGPBrush.Free;
  LGPFontFamily.Free;
  LGPStrFormat.Free;
  LGPPath.Free;
  LGPMatrix.Free;
  LGPPen.Free;
end;

end.
