//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  TGPMatrix  slӌ`̕`̈摜
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1214 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, ComCtrls;

type
  TMyPanel = class(TPanel)
  private
    FXAddValue : Single;
    FYAddValue : Single;
    procedure SetXAddValue(const Value: Single);
    procedure SetYAddValue(const Value: Single);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    property XAddValue : Single read FXAddValue write SetXAddValue;
    property YAddValue : Single read FYAddValue write SetYAddValue;
  end;

  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  TGPMatrix  slӌ`̕`̈摜';

  //`悷Rg[𐶐
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent := Self;
    SetBounds(5, 70, Self.ClientWidth - 10, Self.ClientHeight - 75);
    DoubleBuffered   := True;
    ControlStyle     := MyPanel.ControlStyle + [csOpaque];
    BevelOuter       := bvNone;
    Visible          := True;
    Color            := clWhite;
    ParentBackground := False;
    Anchors          := [akLeft, akTop, akRight, akBottom];
  end;

  //X̒lɉZl̐ݒ
  with TrackBar1 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := -500;
    Max      := 500;
    Position := 0;
  end;

  //Y̒lɉZl̐ݒ
  with TrackBar2 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := -500;
    Max      := 500;
    Position := 0;
  end;
end;

//=============================================================================
//  TrackBar1OnClickCxg
//=============================================================================
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.XAddValue := TrackBar1.Position / 100.0;
end;

//=============================================================================
//  TrackBar2OnClickCxg
//=============================================================================
procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.YAddValue :=  TrackBar2.Position / 100.0;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RXgN^
//  evpeB̏
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  FXAddValue := 0.0;
  FYAddValue := 0.0;
end;

//-----------------------------------------------------------------------------
//  XAddValuevpeBݒp\bh
//  X̒lɉZl̐ݒ
//-----------------------------------------------------------------------------
procedure TMyPanel.SetXAddValue(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FXAddValue <> Value then begin
     FXAddValue := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  YAddValuevpeBݒp\bh
//  Y̒lɉZl̐ݒ
//-----------------------------------------------------------------------------
procedure TMyPanel.SetYAddValue(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FYAddValue <> Value then begin
     FYAddValue := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LImageFilePath : String;
  LObjWidth      : Integer;
  LObjHeight     : Integer;
  LXLocation     : Integer;
  LYLocation     : Integer;
  LGPImage       : TGPImage;
  LGPGraphic     : TGPGraphics;
  LGPMatrix     : TGPMatrix;
begin
  inherited;

  LObjWidth  := 192;
  LObjHeight := 144;

  LXLocation := Width  div 2;
  LYLocation := Height div 2;

  LImageFilePath := ExtractFilePath(ParamStr(0)) + 'Hachi.bmp';
  LGPImage      := TGPImage.Create(LImageFilePath);

  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

@LGPMatrix := TGPMatrix.Create;
@LGPMatrix.SetElements(1.0, FYAddValue,
@@@@@@@@@@    FXAddValue, 1.0,
@@@@@@@@@@    LXLocation, LYLocation);
@LGPGraphic.SetTransform(LGPMatrix);

  LGPGraphic.DrawImage(LGPImage,
                       - LObjWidth  div 2,
                       - LObjHeight div 2,
                       LObjWidth,
                       LObjHeight);

  LGPImage.Free;
  LGPGraphic.Free;
  LGPMatrix.Free;
end;

end.
